/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.description;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.description.DescriptionElementSource;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

/**
 * @author k.luther
 * @since 17.09.2018
 *
 */
public class CommonNameSourceElement extends DescriptionElementSourceElement {

    public CommonNameSourceElement(CdmFormFactory cdmFormFactory, AbstractFormSection<?> formElement,
            DescriptionElementSource element, SelectionListener removeListener, int style) {
        super(cdmFormFactory, formElement, element, removeListener, style, true);
    }

    @Override
    public void createControls(ICdmFormElement formElement, int style) {
        this.isCommonNameReference = true;
        super.createControls(formElement, style);
    }
}