/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.ui.section.description;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.reference.Reference;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 * @author n.hoffmann
 * @created Mar 18, 2010
 */
public class DescriptionSourceElement extends
		AbstractEntityCollectionElement<Reference> {

	private EntitySelectionElement<Reference> selection_descriptionSource;

	public DescriptionSourceElement(CdmFormFactory cdmFormFactory,
			AbstractFormSection formElement, Reference element,
			SelectionListener removeListener, int style) {
		super(cdmFormFactory, formElement, element, removeListener, null, style);
	}

	@Override
	public void createControls(ICdmFormElement element, int style) {
		selection_descriptionSource = formFactory
				.createSelectionElement(Reference.class,
				        element, "Source",
						null, EntitySelectionElement.ALL, style);
		if (entity != null){
			setEntity(entity);
		}
	}

	@Override
	public void setEntity(Reference element) {
		this.entity = element;
		if (selection_descriptionSource != null){
			selection_descriptionSource.setEntity(element);
		}
	}

	@Override
	public void handleEvent(Object eventSource) {

	}
}
