/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.ui.section.description;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.location.NamedArea;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;

/**
 * <p>GeoScopeElement class.</p>
 *
 * @author n.hoffmann
 * @created Sep 17, 2010
 * @version 1.0
 */
public class GeoScopeElement extends AbstractEntityCollectionElement<NamedArea> {

	/**
	 * <p>Constructor for GeoScopeElement.</p>
	 *
	 * @param formFactory a {@link eu.etaxonomy.taxeditor.ui.element.CdmFormFactory} object.
	 * @param section a {@link eu.etaxonomy.taxeditor.ui.element.AbstractFormSection} object.
	 * @param entity a {@link eu.etaxonomy.cdm.model.location.NamedArea} object.
	 * @param removeListener a {@link org.eclipse.swt.events.SelectionListener} object.
	 * @param style a int.
	 */
	public GeoScopeElement(CdmFormFactory formFactory,
			AbstractFormSection section, NamedArea entity,
			SelectionListener removeListener, int style) {
		super(formFactory, section, entity, removeListener, null, style);
	}

	/** {@inheritDoc} */
	@Override
	public void setEntity(NamedArea entity) {
		this.entity = entity;

	}

	/** {@inheritDoc} */
	@Override
	public void createControls(ICdmFormElement element, int style) {

	}

	/** {@inheritDoc} */
	@Override
	public void handleEvent(Object eventSource) {
	}


}
