/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.description.detail;

import eu.etaxonomy.cdm.model.common.ExtendedTimePeriod;
import eu.etaxonomy.cdm.model.description.TemporalData;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ExtendedTimePeriodElement;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

/**
 * @author k.luther
 * @since Jun 12, 2020
 */
public class TemporalDataDetailElement extends AbstractDetailedDescriptionDetailElement<TemporalData> {

    ExtendedTimePeriodElement timePeriod;

    /**
     * @param formFactory
     * @param formElement
     * @param entity
     * @param style
     */
    public TemporalDataDetailElement(CdmFormFactory formFactory, ICdmFormElement formElement, TemporalData entity, boolean enabled,
            int style) {
        super(formFactory, formElement, entity, enabled, style);

    }

    @Override
    protected void createControls(ICdmFormElement formElement, TemporalData entity, int style) {
        ExtendedTimePeriod period = entity.getPeriod();
        if (period == null){
            period = ExtendedTimePeriod.NewExtendedInstance();
            entity.setPeriod(period);
        }
        timePeriod = formFactory.createExtendedTimePeriodElement(formElement, "", entity.getPeriod(), style);


    }

}
