/**
* Copyright (C) 2009 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.feature;

import org.apache.commons.lang3.StringUtils;
import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.term.TermNode;
import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;

/**
 *
 * @author pplitzner
 * @since Dec 21, 2017
 *
 */
public class TermNodeDetailSection extends AbstractCdmDetailSection<TermNodeDto> {

	public TermNodeDetailSection(CdmFormFactory formFactory,
	        ConversationHolder conversation, ICdmFormElement parentElement,
			ISelectionProvider selectionProvider, int style) {
		super(formFactory, conversation, parentElement, selectionProvider, style);
	}

	@Override
	public String getHeading() {
	    String[] r = TermNode.class.getSimpleName().split("(?=\\p{Upper})");
        String header = StringUtils.join(r," ");
		return header;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    protected AbstractCdmDetailElement<TermNodeDto> createCdmDetailElement(AbstractCdmDetailSection<TermNodeDto> parentElement,
            int style) {
        return formFactory.createFeatureNodeDetailElement(parentElement, style);
    }

}
