/**
* Copyright (C) 2012 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.ui.section.grantedAuthority;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.permission.GrantedAuthorityImpl;
import eu.etaxonomy.cdm.model.permission.Group;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 * @author a.kohlbecker
 * @date Sept 12 2012
 *
 */
public class GrantedAuthorityCollectionElement extends AbstractEntityCollectionElement<GrantedAuthorityImpl> {

	private EntitySelectionElement<GrantedAuthorityImpl> selection_authority;
	private Group grantedAuthorityUser;


	public GrantedAuthorityCollectionElement(CdmFormFactory formFactory,
			AbstractFormSection section, GrantedAuthorityImpl entity, Group group,
			SelectionListener removeListener, int style) {
		super(formFactory, section, entity, removeListener, null, style);
		this.grantedAuthorityUser = group;
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#setEntity(java.lang.Object)
	 */
	@Override
	public void setEntity(GrantedAuthorityImpl entity) {
		this.entity = entity;

	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#createControls(eu.etaxonomy.taxeditor.ui.element.ICdmFormElement, int)
	 */
	@Override
	public void createControls(ICdmFormElement element, int style) {
		selection_authority = formFactory.createSelectionElement(
					GrantedAuthorityImpl.class, //getConversationHolder(),
					element, "", getEntity(), EntitySelectionElement.SELECTABLE, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#handleEvent(java.lang.Object)
	 */
	@Override
	public void handleEvent(Object eventSource) {
		if (eventSource == selection_authority) {
		    GrantedAuthorityImpl oldGrantedAuthority = entity;
		    grantedAuthorityUser.removeGrantedAuthority(entity);

			setEntity(selection_authority.getEntity());
			grantedAuthorityUser.addGrantedAuthority(entity);

		}
	}


}
