/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.name;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
import eu.etaxonomy.taxeditor.ui.section.ITaxonBaseDetailSection;

/**
 * @author n.hoffmann
 * @created Jan 5, 2011
 */
public class HybridDetailSection
        extends AbstractCdmDetailSection<TaxonName>
        implements ITaxonBaseDetailSection {

	private TaxonBase<?> taxonBase;

	public HybridDetailSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement,
			ISelectionProvider selectionProvider, int style) {
		super(formFactory, conversation, parentElement, selectionProvider, style);
	}

	@Override
	public void setTaxonBase(TaxonBase taxon) {
		taxonBase = taxon;
		TaxonName name = HibernateProxyHelper.deproxy(taxon.getName());
		setEntity(name);
	}

	@Override
	public TaxonBase getTaxonBase() {
		return taxonBase;
	}

	@Override
	public String getHeading() {
		return "Hybrid";
	}

	@Override
	protected void setSectionTitle() {
		setText(getHeading());
	}

	@Override
	protected AbstractCdmDetailElement createCdmDetailElement(
			AbstractCdmDetailSection<TaxonName> parentElement, int style) {
        //FIXME generic
	    return formFactory.createHybridDetailElement(parentElement);
	}

	public void updateContent() {
		((AbstractCdmDetailElement)this.detailElement).setEntity(getEntity());
	}
}