/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.ui.section.occurrence;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;

/**
 * <p>DeterminationEventDetailSection class.</p>
 *
 * @author n.hoffmann
 * @created Oct 13, 2010
 */
public abstract class AbstractDeterminationEventDetailSection
        extends AbstractEntityCollectionSection<SpecimenOrObservationBase, DeterminationEvent> {

	public AbstractDeterminationEventDetailSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement,
			String title, int style) {
		super(formFactory, conversation, parentElement, title, style);
	}

	@Override
	public DeterminationEvent createNewElement() {
		DeterminationEvent instance = DeterminationEvent.NewInstance();
        if(PreferencesUtil.isDeterminationOnlyForFieldUnits()){
            instance.setIdentifiedUnit(getEntity());
        }
        else{
            instance.setIdentifiedUnit(getEntity());
        }
		return instance;
	}

	@Override
	public void addElement(DeterminationEvent determination) {
		getEntity().addDetermination(determination);
	}

	@Override
	public void removeElement(DeterminationEvent determination) {
		getEntity().removeDetermination(determination);
	}

	@Override
	public String getEmptyString() {
		return "No determinations yet.";
	}
}