/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.ui.section.occurrence;

import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
import eu.etaxonomy.cdm.model.term.DefinedTerm;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.ui.combo.term.TermComboElement;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

public abstract class AbstractSpecimenOrObservationDetailElement extends AbstractCdmDetailElement<DerivedUnitFacade> {

	private TermComboElement<DefinedTerm> combo_kindOfUnit;

	private TermComboElement<DefinedTerm> combo_lifeStage;

	private TermComboElement<DefinedTerm> combo_sex;

	public AbstractSpecimenOrObservationDetailElement(CdmFormFactory formFactory, ICdmFormElement formElement) {
		super(formFactory, formElement);
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void createControls(ICdmFormElement formElement,
			DerivedUnitFacade entity, int style) {

	    setWarnForReferencingObjects(formElement);
		combo_kindOfUnit= formFactory.createDefinedTermComboElement(TermType.KindOfUnit, formElement, "Kind Of Unit", entity.getDerivedUnitKindOfUnit(), style);
		combo_lifeStage = formFactory.createDefinedTermComboElement(TermType.Stage, formElement, "Life Stage", entity.getLifeStage(), style);
		combo_sex = formFactory.createDefinedTermComboElement(TermType.Sex, formElement, "Sex", entity.getSex(),style);
	}

	@Override
	public void handleEvent(Object eventSource) {
		if(eventSource == combo_kindOfUnit){
		    getEntity().setDerivedUnitKindOfUnit(combo_kindOfUnit.getSelection());
		}
		else if(eventSource == combo_lifeStage){
			getEntity().setLifeStage(combo_lifeStage.getSelection());
		}
		else if(eventSource == combo_sex){
			getEntity().setSex(combo_sex.getSelection());
		}
	}

}
