/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.occurrence;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;

/**
 * @author n.hoffmann
 * @created May 11, 2011
 */
public class DeterminationDetailSection
            extends AbstractCdmDetailSection<SpecimenOrObservationBase>
            implements IDerivedUnitFacadeDetailSection {

	public DeterminationDetailSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement,
			ISelectionProvider selectionProvider, int style) {
		super(formFactory, conversation, parentElement, selectionProvider, style);
	}

	@Override
	public String getHeading() {
		String sectionTitle = "Determinations";
		if(getEntity()!=null && getEntity().getDeterminations().size()>0){
			return sectionTitle+" +";
		}
		return sectionTitle;
	}

	@Override
	protected AbstractCdmDetailElement<SpecimenOrObservationBase> createCdmDetailElement(AbstractCdmDetailSection<SpecimenOrObservationBase> parentElement, int style) {
	    return formFactory.createDeterminationDetailElement(parentElement);
	}
}