/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.occurrence;

import java.util.Collection;
import java.util.Comparator;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.DefaultCdmBaseComparator;

/**
 * @author n.hoffmann
 * @created May 11, 2011
 */
public class DeterminationHistoryDetailSection extends
		AbstractDeterminationEventDetailSection {

	public DeterminationHistoryDetailSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement,
			int style) {
		super(formFactory, conversation, parentElement, "Determination History", style);
	}

	@Override
	public Collection<DeterminationEvent> getCollection(SpecimenOrObservationBase entity) {
		return entity != null ? entity.getOtherDeterminations() : null;
	}

	@Override
	public Comparator<DeterminationEvent> getComparator() {
        return new DefaultCdmBaseComparator<>();
	}

	@Override
	public void refresh() {
		internalUpdateSection(false);
	}

	@Override
	protected String getTooltipString() {
		return "Add a determination event to the history";
	}

    @Override
    public DeterminationEvent addExisting() {
        return null;
    }

    @Override
    public boolean allowAddExisting() {
        return false;
    }
}