/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.occurrence;

import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;

/**
 * @author pplitzner
 * @date 27.01.2014
 *
 */
public class EmptySection extends AbstractCdmDetailSection<Object> {

    private static final String DEFAULT_MESSAGE = Messages.EmptySection_NO_VIEW_IMPLEMENTED;
    private final String message;

    public EmptySection(String message, CdmFormFactory formFactory, ICdmFormElement parentElement, int style) {
        super(formFactory, null, parentElement, null, style);
        this.message = message!=null?message:DEFAULT_MESSAGE;
    }

    /** {@inheritDoc} */
    @Override
    public String getHeading() {
        return message!=null?message:DEFAULT_MESSAGE;
    }

    @Override
    protected AbstractCdmDetailElement<Object> createCdmDetailElement(AbstractCdmDetailSection<Object> parentElement, int style) {
        return formFactory.createEmptyElement(parentElement, message);
    }

    @Override
    public void setEntity(Object entity) {
        //update section title because getHeading is invoked
        //before message is set via constructor
        setSectionTitle();
    }
}
