package eu.etaxonomy.taxeditor.ui.section.occurrence;

import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;

import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
import eu.etaxonomy.cdm.model.common.ExtensionType;
import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
import eu.etaxonomy.cdm.model.occurrence.OccurrenceStatus;
import eu.etaxonomy.cdm.model.term.DefinedTerm;
import eu.etaxonomy.cdm.model.term.DefinedTermBase;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.ui.combo.term.TermComboElement;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.SelectionArbitrator;
import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.section.reference.SingleSourceSection;
import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractOriginalSourceElement;
import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractSingleSourceElement;
import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractSourcedEntityBaseElement;
import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractSourcedEntityElement;
import eu.etaxonomy.taxeditor.ui.section.supplemental.IdentifiableSourceElement;

public class OccurrenceStatusElement extends AbstractSourcedEntityElement<OccurrenceStatus>{

	private TermComboElement<DefinedTerm> combo_statusType;	
	
//	private IdentifiableSourceElement sourceElement;

	
	public OccurrenceStatusElement(CdmFormFactory formFactory, AbstractFormSection section, OccurrenceStatus entity, SelectionListener removeListener, int style) {
		super(formFactory, section, entity, removeListener, "Status", style);
		
	}

	@Override
	public void setEntity(OccurrenceStatus entity) {
		super.setEntity(entity);
		if (combo_statusType != null){
			DefinedTerm statusType = HibernateProxyHelper.deproxy(entity.getType());
			combo_statusType.setSelection(statusType);			
		}
		this.setSourceLabel("Source");
		
		
	}

	@Override
	public void createControls(ICdmFormElement element, int style) {
		combo_statusType = formFactory.createDefinedTermComboElement(TermType.OccurrenceStatusType, element, "Type", null, style);
		if (entity != null){
			setEntity(entity);
		}
		super.createControls(element, style);
		this.setSourceLabel("Source");
		
	}

	@Override
	public void handleEvent(Object eventSource) {
		if(eventSource == combo_statusType){
			getEntity().setType(combo_statusType.getSelection());
		}
		if (getParentElement() instanceof AbstractCdmDetailSection) {
            ((AbstractCdmDetailSection<?>) getParentElement()).updateTitle();
        }
		
	}

	@Override
	public SelectionArbitrator getSelectionArbitrator() {
		// TODO Auto-generated method stub
		return null;
	}

	
}
