/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.ui.section.reference;

import eu.etaxonomy.cdm.model.name.NomenclaturalSource;
import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

/**
 * <p>
 * NomenclaturalReferenceDetailElement class.
 * </p>
 *
 * @author n.hoffmann
 * @created Mar 12, 2010
 */
public class NomenclaturalSourceDetailElement extends
		AbstractCdmDetailElement<TaxonName> {

    private OriginalSourceElement sourceElement;

	/**
	 * <p>
	 * Constructor for NomenclaturalReferenceDetailElement.
	 * </p>
	 *
	 * @param cdmFormFactory
	 *            a {@link eu.etaxonomy.taxeditor.ui.element.CdmFormFactory}
	 *            object.
	 * @param formElement
	 *            a {@link eu.etaxonomy.taxeditor.ui.element.ICdmFormElement}
	 *            object.
	 * @param style
	 *            a int.
	 */
	public NomenclaturalSourceDetailElement(CdmFormFactory cdmFormFactory,
			ICdmFormElement formElement, int style) {
		super(cdmFormFactory, formElement);
	}

	@Override
	protected void createControls(ICdmFormElement formElement,
			TaxonName entity, int style) {

	    sourceElement = formFactory.createNomenclaturalSourceElement(formElement, entity, "Reference");
	    if (entity.getNomenclaturalSource() == null){
            NomenclaturalSource source = NomenclaturalSource.NewNomenclaturalInstance(entity);
            entity.setNomenclaturalSource(source);
            sourceElement.setEntity(source);
        }else{
            sourceElement.setEntity(entity.getNomenclaturalSource());
        }
	    sourceElement.setPersistentBackground(formElement.getPersistentBackground());

	}

	@Override
	public void handleEvent(Object eventSource) {

	}


}
