/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.reference;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import eu.etaxonomy.cdm.common.CdmUtils;
import eu.etaxonomy.cdm.model.reference.Reference;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;

/**
 * @author k.luther
 * @date 27.03.2017
 *
 */
public class ReferencingObjectsMessagesSection extends AbstractFormSection {


    private Reference reference;
    private Label warnForReferencedObjects;
    
    public ReferencingObjectsMessagesSection(CdmFormFactory formFactory, ICdmFormElement layoutComposite, int style, Reference reference){
        super(formFactory, layoutComposite, style);
        this.reference = reference;
    }

    private void displayReferencingObjectsMessage() {

        if (reference.getId() != 0){
            long referencingObjectsCount = CdmStore.getCommonService().getReferencingObjectsCount(reference);
            if (referencingObjectsCount > 1){

                    warnForReferencedObjects = formFactory.createLabel(getLayoutComposite(), CdmUtils.Nz("The reference is referenced by " + referencingObjectsCount+ " objects, if you change it, it is changed for all these objects"));
                    warnForReferencedObjects.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_RED));
                    warnForReferencedObjects.setLayoutData(LayoutConstants.FILL(1, 1));
                    warnForReferencedObjects.setForeground(Display.getCurrent().getSystemColor(
                            SWT.COLOR_RED));

                //warnForReferencedObjects.setVisible(false);
            }
        }
    }
}
