package eu.etaxonomy.taxeditor.ui.section.reference;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.name.NomenclaturalSource;
import eu.etaxonomy.cdm.model.taxon.SecundumSource;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
import eu.etaxonomy.taxeditor.ui.section.ITaxonBaseDetailSection;

public class SecundumSourceSection extends AbstractCdmDetailSection<TaxonBase>  {
	

	public SecundumSourceSection(CdmFormFactory formFactory, ConversationHolder conversation, ICdmFormElement parentElement, ISelectionProvider selectionProvider,
			int style) {
		super(formFactory, conversation, parentElement, selectionProvider, style);
		
	}

	@Override
	public String getHeading() {
		
		return "Secundum Source";
	}
	
	@Override
	protected void setSectionTitle() {
		String title = "";
		if(getEntity() != null ){
			
			if (getEntity().getSecSource() != null && getEntity().getSecSource().getCitation() != null){
			    String secundumCitation = getEntity().getSecSource().getCitation().getNomenclaturalCitation(getEntity().getSecSource().getCitationMicroReference());
			    title = ": " + secundumCitation;
			}

		}
		this.setText(getHeading() + title);
	}

	@Override
	protected AbstractCdmDetailElement<TaxonBase> createCdmDetailElement(
			AbstractCdmDetailSection<TaxonBase> parentElement, int style) {
		
		return formFactory.createSecundumSourceDetailElement(parentElement);
	}

}
