/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.reference;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.reference.OriginalSourceBase;
import eu.etaxonomy.cdm.model.reference.Reference;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;

/**
 * @author k.luther
 * @since Jul 2, 2020
 */
public class SingleSourceSection extends AbstractCdmDetailSection<OriginalSourceBase> {

    private CdmBase cdmEntity;
    private String label;

    public SingleSourceSection(CdmFormFactory formFactory, ConversationHolder conversation,
            ICdmFormElement parentElement, CdmBase cdmEntity, ISelectionProvider selectionProvider, int style, String label) {
        super(formFactory, conversation, parentElement, selectionProvider, style);
        this.cdmEntity = cdmEntity;
        this.label = label;
        ((OriginalSourceElement)this.detailElement).setCdmEntity(cdmEntity);
    }

    @Override
    protected AbstractCdmDetailElement<OriginalSourceBase> createCdmDetailElement(
            AbstractCdmDetailSection<OriginalSourceBase> parentElement, int style) {

        return new OriginalSourceElement(getFormFactory(), parentElement, cdmEntity, label);
    }

    @Override
    public String getHeading() {
        return "";
    }

    public Reference getRef() {
        return detailElement.getEntity().getCitation();
    }
}
