/**
 *
 */
package eu.etaxonomy.taxeditor.ui.section.supplemental;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.common.Annotation;
import eu.etaxonomy.cdm.model.common.AnnotationType;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.ui.combo.term.TermComboElement;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;

/**
 * <p>AnnotationElement class.</p>
 *
 * @author nho
 */
public class AnnotationElement extends AbstractEntityCollectionElement<Annotation>{

	private TextWithLabelElement text;
	private TermComboElement<AnnotationType> combo_annotationType;

	/**
	 * <p>Constructor for AnnotationElement.</p>
	 *
	 * @param formElement a {@link eu.etaxonomy.taxeditor.ui.element.AbstractFormSection} object.
	 * @param annotation a {@link eu.etaxonomy.cdm.model.common.Annotation} object.
	 * @param style a int.
	 * @param cdmFormFactory a {@link eu.etaxonomy.taxeditor.ui.element.CdmFormFactory} object.
	 * @param removeListener a {@link org.eclipse.swt.events.SelectionListener} object.
	 */
	public AnnotationElement(CdmFormFactory cdmFormFactory, AbstractFormSection formElement, Annotation annotation, SelectionListener removeListener, int style) {
		super(cdmFormFactory, formElement, annotation, removeListener, null, style);
	}

	@Override
	public void createControls(ICdmFormElement element, int style) {
		combo_annotationType = formFactory.createDefinedTermComboElement(TermType.AnnotationType, this, "Annotation Type", null, style);

		text = formFactory.createMultiLineTextWithLabel(this, "Annotation", 100, style);
		if (entity != null){
			setEntity(entity);
		}
	}

	@Override
	public void setEntity(Annotation entity) {
		this.entity = entity;
		if (combo_annotationType != null){
			combo_annotationType.setSelection(getEntity().getAnnotationType());
			text.setText(entity.getText());
		}
	}

	@Override
	public void handleEvent(Object eventSource) {
		if(eventSource == combo_annotationType){
			getEntity().setAnnotationType(combo_annotationType.getSelection());
		}else if(eventSource == text){
			getEntity().setText(text.getText());
		}
	}
}
