/**
 *
 */
package eu.etaxonomy.taxeditor.ui.section.supplemental;


import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
import eu.etaxonomy.cdm.model.common.ICdmBase;
import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
import eu.etaxonomy.taxeditor.store.StoreUtil;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

/**
 * <p>HeadlineSection class.</p>
 *
 * @author n.hoffmann
 */
public class HeadlineSection extends AbstractFormSection<ICdmBase> {

	/**
	 * <p>Constructor for HeadlineSection.</p>
	 *
	 * @param cdmFormFactory a {@link eu.etaxonomy.taxeditor.ui.element.CdmFormFactory} object.
	 * @param parentElement a {@link eu.etaxonomy.taxeditor.ui.element.ICdmFormElement} object.
	 * @param style a int.
	 */
	public HeadlineSection(CdmFormFactory cdmFormFactory, ICdmFormElement parentElement,
			int style) {
		super(cdmFormFactory, parentElement, style);
	}

	@Override
	public void setEntity(ICdmBase cdmBase) {
		ICdmBase entity = HibernateProxyHelper.deproxy(cdmBase);
		super.setEntity(entity);

		String simpleName = entity.getClass().getSimpleName();
        String titleString = entity instanceof IdentifiableEntity ? ": " + ((IdentifiableEntity<?>) entity).generateTitle() : "";
        titleString = StoreUtil.cleanTitleString(titleString);
        setText(simpleName + titleString);
		layout();
	}

}
