package eu.etaxonomy.taxeditor.ui.section.supplemental;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
import eu.etaxonomy.cdm.model.common.Marker;
import eu.etaxonomy.cdm.model.common.MarkerType;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.ui.combo.term.TermComboElement;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;

/**
 * @author n.hoffmann
 * @created Nov 16, 2009
 * @version 1.0
 */
public class MarkerElement extends AbstractEntityCollectionElement<Marker>{


	private TermComboElement<MarkerType> combo_markerType;
	private CheckboxElement checkbox_markerState;

	public MarkerElement(CdmFormFactory cdmFormFactory, AbstractFormSection formElement, Marker element,
	        SelectionListener removeListener, int style) {
	    super(cdmFormFactory, formElement, element, removeListener, null, style);
	}

	/** {@inheritDoc} */
	@Override
	public void createControls(ICdmFormElement element, int style) {
		checkbox_markerState = formFactory.createCheckbox(this, null, false, style);
		combo_markerType = formFactory.createDefinedTermComboElement(TermType.MarkerType, this, null, null, style);
		if (entity != null){
			setEntity(entity);
		}
	}

	/** {@inheritDoc} */
	@Override
	public void setEntity(Marker element) {
		this.entity = element;
		if (checkbox_markerState != null){
			checkbox_markerState.setSelection(element.getFlag());
			combo_markerType.setSelection(element.getMarkerType());
			combo_markerType.removeEmptyElement();
		}
	}

	/** {@inheritDoc} */
	@Override
	public void handleEvent(Object eventSource) {
		if(eventSource == combo_markerType && getParentElement() instanceof MarkerSection){
		    MarkerSection markerSection = (MarkerSection)getParentElement();
		    AnnotatableEntity annotatableEntity = markerSection.getEntity();
		    annotatableEntity.removeMarker(entity);
			MarkerType markerType = combo_markerType.getSelection();
			entity.setMarkerType(markerType);
			annotatableEntity.addMarker(entity);
		}
		else if(eventSource == checkbox_markerState){
			getEntity().setFlag(checkbox_markerState.getSelection());
		}
	}
}
