/**
 *
 */
package eu.etaxonomy.taxeditor.ui.section.supplemental;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.agent.AgentBase;
import eu.etaxonomy.cdm.model.media.Rights;
import eu.etaxonomy.cdm.model.media.RightsType;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.ui.combo.term.TermComboElement;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
import eu.etaxonomy.taxeditor.ui.element.UriWithLabelElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 * @author n.hoffmann
 * @created Nov 16, 2009
 */
public class RightsElement extends AbstractEntityCollectionElement<Rights>{

	private TermComboElement<RightsType> combo_rightsType;
	private EntitySelectionElement<AgentBase> selection_agent;
	private TextWithLabelElement text;
	private TextWithLabelElement abbrev;
	private UriWithLabelElement uri;

	public RightsElement(CdmFormFactory cdmFormFactory,
			AbstractFormSection formElement, Rights element,
			SelectionListener removeListener, int style) {
		super(cdmFormFactory, formElement, element, removeListener, null, style);
	}

	@Override
	public void createControls(ICdmFormElement element, int style) {
		combo_rightsType = formFactory.createDefinedTermComboElement(TermType.RightsType, this, "Rights Type", null, style);
		selection_agent = formFactory.createSelectionElement(
				AgentBase.class, //getConversationHolder(),
				this, "Agent",
				null, EntitySelectionElement.ALL, style);
		text = formFactory.createMultiLineTextWithLabel(this, "Text", 100,
				style);
		abbrev = formFactory.createTextWithLabelElement(element, "Abbrev. Text", null, style);

		uri = formFactory.createUriWithLabelElement(element, "Uri", null, style);
		if (entity != null){
			setEntity(entity);
		}

	}

	@Override
	public void setEntity(Rights element) {
		this.entity = element;
		if(combo_rightsType != null){
			combo_rightsType.setSelection(element.getType());
			selection_agent.setEntity(element.getAgent());
			text.setText(element.getText());
			abbrev.setText(element.getAbbreviatedText());
			uri.setParsedText(element.getUri());
		}
	}

	@Override
	public void handleEvent(Object eventSource) {
		if (eventSource == combo_rightsType) {
			entity.setType(combo_rightsType.getSelection());
		} else if (eventSource == selection_agent) {
			entity.setAgent(selection_agent.getSelection());
		} else if (eventSource == text) {
			entity.setText(text.getText());
		}else if (eventSource == abbrev) {
            entity.setAbbreviatedText(abbrev.getText());
        }else if (eventSource == uri) {
            entity.setUri(uri.parseText());
        }
	}
}