/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.ui.section.supplemental.identifier;

import java.util.Collection;
import java.util.Comparator;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
import eu.etaxonomy.cdm.model.common.Identifier;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.DefaultCdmBaseComparator;

/**
 *
 * @author pplitzner
 *
 */
public class DerivedUnitFacadeIdentifierSection extends AbstractIdentifierSection<DerivedUnitFacade> {


	public DerivedUnitFacadeIdentifierSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement,
			int style) {
		super(formFactory, conversation, parentElement, style);
	}

	@Override
	public Collection<Identifier> getCollection(DerivedUnitFacade entity) {
		return entity.getIdentifiers();
	}

	@Override
	public Comparator<Identifier> getComparator() {
        return new DefaultCdmBaseComparator<>();
	}


	@Override
	public void addElement(Identifier element) {
		getEntity().addIdentifier(element);
	}


	@Override
	public void removeElement(Identifier element) {
		getEntity().removeIdentifier(element);
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Identifier addExisting() {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean allowAddExisting() {
        // TODO Auto-generated method stub
        return false;
    }

}
