/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.occurrence.dna;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.molecular.SingleRead;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;

/**
 * @author pplitzner
 * @date 06.01.2014
 *
 */
public class SingleReadGeneralDetailSection extends AbstractCdmDetailSection<SingleRead>{

    /**
     * @param formFactory
     * @param conversation
     * @param parentElement
     * @param selectionProvider
     * @param style
     */
    public SingleReadGeneralDetailSection(CdmFormFactory formFactory,
            ConversationHolder conversation, ICdmFormElement parentElement,
            ISelectionProvider selectionProvider, int style) {
        super(formFactory, conversation, parentElement, selectionProvider, style);
    }


    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.section.AbstractCdmDetailSection#getHeading()
     */
    @Override
    public String getHeading() {
        return "General";
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection#createCdmDetailElement(eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection, int)
     */
    @Override
    protected AbstractCdmDetailElement<SingleRead> createCdmDetailElement(AbstractCdmDetailSection<SingleRead> parentElement, int style) {
        return formFactory.createSingleReadGeneralDetailElement(parentElement);
    }

}
